// Beziehungskisten - Demo fuer Stream++

#include <iostream.h>
#include "streampp.h"
extern TStrKeyCollection ClassManager;
                             
DefClass(Beziehungstyp)
class Beziehungstyp : public TPersistent
{
  protected:
      Pchar name;
      PBeziehungstyp partner;
  public:
      Beziehungstyp(Pchar _name,PBeziehungstyp _partner = NULL);
      Beziehungstyp(PTIRefStream is);
      ~Beziehungstyp();
      DefNameBuild(Beziehungstyp)

      virtual void Store(PTORefStream os);
      virtual Pchar Name();
      virtual void StellDichVor();
      virtual Pchar WenKenneIch();
      virtual void WaehlePartner(PBeziehungstyp _partner);
};

inline  TIRefStream& operator>> (TIRefStream& is, PBeziehungstyp& dest)
{
  PTPersistent temp;
  is >> temp;
  dest=(PBeziehungstyp)temp;
  return is;
}

Beziehungstyp::Beziehungstyp(Pchar _name,PBeziehungstyp _partner)
{
  name = (char*) malloc(strlen(_name)+1);
  strcpy(name,_name);
  partner = _partner;
};

Beziehungstyp::Beziehungstyp(PTIRefStream is):TPersistent(is)
{
  is->ReadDynamicString(name);
  *is >> partner;
};

void Beziehungstyp::Store(PTORefStream os)
{
  os->WriteDynamicString(name);
  *os << partner;
};

Beziehungstyp::~Beziehungstyp()
{
  free(name);
};

Pchar Beziehungstyp::Name()
{
  return name;
};

void Beziehungstyp::StellDichVor()
{
  cout << "Ich heisse " << name << " und kenne " << WenKenneIch() << ".\n";
};

Pchar Beziehungstyp::WenKenneIch()
{
  return partner->Name();
};

void Beziehungstyp::WaehlePartner(PBeziehungstyp _partner)
{
  partner = _partner;
};

void main()
{
  RegClass(Beziehungstyp)

  cout << "VOR DEM SPEICHERN ...\n\n"
       << "Eine voellig normale Beziehung:\n";
  PBeziehungstyp Willi = new Beziehungstyp("Willi");
  PBeziehungstyp Gertrude = new Beziehungstyp("Gertrud");
  Willi->WaehlePartner(Gertrude);
  Gertrude->WaehlePartner(Willi);
  Willi->StellDichVor();
  Gertrude->StellDichVor();
  cout << "\nUnd ein Dreiecksverhaeltnis mit egoistischen Anteilen:\n";
  PBeziehungstyp Lieschen = new Beziehungstyp("Lieschen");
  PBeziehungstyp Fritz = new Beziehungstyp("Fritz",Lieschen);
  PBeziehungstyp Hansi = new Beziehungstyp("Hansi",Lieschen);
  Lieschen->WaehlePartner(Lieschen);
  Fritz->StellDichVor();
  Hansi->StellDichVor();
  Lieschen->StellDichVor();

  TOFRefStream os("kiste");
  os << Lieschen << Fritz << Hansi << Willi << Gertrude;
  os.Close();

  delete Lieschen;delete Fritz;delete Hansi;
  delete Willi;delete Gertrude;

  TIFRefStream is("kiste");
  is >> Lieschen >> Fritz >> Hansi >> Willi >> Gertrude;

  cout << "\n\nNACH DEM LADEN ...\n\n"
       << "Eine voellig normale Beziehung:\n";
  Willi->StellDichVor();
  Gertrude->StellDichVor();
  cout << "\nUnd ein Dreiecksverhaeltnis mit egoistischen Anteilen:\n";
  Fritz->StellDichVor();
  Hansi->StellDichVor();
  Lieschen->StellDichVor();
}